require 'web'
require 'loginpd'
require 'todopd'

class Session < Web::Session
  def initialize
    super
    @base = BaseProducer.new(self)
    @hint = 'guest' if hint.nil? || hint.empty?
  end
  def service(context)
    request(context)
    context.content = @base.to_html(context)
  end
  def login(name, password)
    $app.login.login(name, password)
    @username = name
    @hint = @username
  end
end
class BaseProducer < Web::Producer
set_erb('base.erb')
  def initialize(session)
    super(session)
    @login = LoginProducer.new(session)
    @todo = TodoProducer.new(session, $app.todo)
  end
end
class Application < Web::Application
  attr_reader :login, :todo
  def initialize
    super(Session)
    @login = Login.new
    @todo = Todo.new
  end
end

$app = Application.new
require 'drb'
DRb.start_service('druby://localhost:9161', $app)
puts 'URI: ' + DRb.uri
DRb.thread.join
