require 'drb'
DRb.start_service

require 'cgi'
  class CGIContext
    include DRbUndumped
    attr_accessor :content
    def initialize(cgi)
      @cgi = cgi
      @cookies = []
      @header = {}
    end
    def req_params
      @cgi.params
    end
    def req_cookie(name)
      @cgi.cookies[name][0]
    end
    def req_cookies
      hash = {}
      @cgi.cookies.each{|k,v| hash[k] = v[0] }
      hash
    end
    def res_add_cookie(name, value, expires=nil)
      cookie = CGI::Cookie.new(name, value)
      cookie.expires = expires if expires
      @cookies.push cookie
    end
    def close
      @header['cookie'] = @cookies
      @header['charset'] = 'Shift_JIS'
#     @header['content-length'] = @content.size.to_s
      @header['pragma'] = 'no-cache'
      @header['cache-control'] = 'no-cache'
      @cgi.out(@header) { @content }
    end
  end

begin
  cgi = CGI.new
  context = CGIContext.new(cgi)
  uri = 'druby://localhost:9161'
  app = DRbObject.new(nil, uri)
  app.run(context)
rescue
  puts $!
  $@.each{|i| puts i}
end
