# require 'thread'
# require 'pstore'

class Todo

class ItemTmpl
  attr_accessor :subject, :time_beg, :time_end
end

class Item < ItemTmpl
  attr_reader :key
  attr_accessor :date, :subject, :time_beg, :time_end
    def Item.new_key
      require 'digest/md5'
      md5 = Digest::MD5::new
      md5.update(String(Time::now))
      md5.update(String(rand(0)))
      md5.update(String($$))
      md5.update('foobar')
      md5.hexdigest[0,16]
    end
  def initialize(key, date, subject, time_beg, time_end)
    @date = date
    @subject = subject
    @time_beg = time_beg
    @time_end = time_end
    @key = key || Item.new_key
  end
  def self.new_from_str(str)
    key, date, subject, time_beg, time_end = str.split(/\t/)
    self.new(key, date, subject, time_beg, time_end)
  end
  def to_s
    [@key, @date, @subject, @time_beg, @time_end].tr("\t"," ").join("\t")
  end
  def to_hash
    { :key => @key, :date => @date, :subject => @subject,
      :time_beg => @time_beg, :time_end => @time_end }
  end
  def edit(date, subject, time_beg, time_end)
    @date = date
    @subject = subject
    @time_beg = time_beg
    @time_end = time_end
  end
end

  @@filename = 'todo.db'
  def self.filename=(fname)
    @@filename = fname
  end

  @@dir = 'todo_db'
  def self.dir=(dir)
    @@dir = dir
  end

  attr_reader :item
  def initialize
    @item = []
  # @mutex = Mutex.new
  # @pstore = PStore.new(@@filename)
  # load
    Dir.glob(File.join(@@dir, '*')) do |entry|
      File.open(entry, "rb") do |f|
        item = Item.new_from_str(f.read)
        @item.push item
      end
    end
  end

  def add(date, subject, time_beg, time_end)
    item = Item.new(nil, date, subject, time_beg, time_end)
    @item.push item
  # save
    File.open(File.join(@@dir, item.key), "wb") do |f|
      f.print item
    end
  end

  def edit(key, date, subject, time_beg, time_end)
    item = find(key)
    item.edit(date, subject, time_beg, time_end)
  # save
    File.open(File.join(@@dir, item.key), "wb") do |f|
      f.print item
    end
  end

  def remove(key)
    item = find(key)
    if item
      @item.delete item
    # save
      File.delete File.join(@@dir, item.key)
    end
  end

  def find(key)
    @item.find{|item| item.key == key }
  end

  def fetch_hash_all
    @item.map{|item| item.to_hash }
  end

  def fetch_hash(key)
    find(key).to_hash
  end

private
# def load
#   @mutex.synchronize do
#     @pstore.transaction do |db|
#       db['item'] = [] unless db.root?('item')
#       @item = db['item']
#     end
#     @item = [] unless @item
#   end
# end

# def save
#   @mutex.synchronize do
#     @pstore.transaction do |db|
#       db['item'] = @item
#       db.commit
#     end
#   end
# end
end

