require 'todo'

class TodoProducer < Web::Producer
  set_erb('todo.erb')
  def initialize(session, todo)
    super(session)
    @todo = todo
    @mode = :browse
  end
  def add(date, subject, time_beg, time_end)
    @todo.add(date, subject, time_beg, time_end)
  end
  def edit(key, date, subject, time_beg, time_end)
    @todo.edit(key, date, subject, time_beg, time_end)
  end
  def remove(key)
    @todo.remove(key)
  end
  def do_add(context, params)
    date, = params['date']
    subject, = params['subject']
    time_beg, = params['time_beg']
    time_end, = params['time_end']
    add(date, subject, time_beg, time_end)
  end
  def do_edit(context, params)
    case @mode
    when :browse
      key, = params['key']
      @currkey = key
      @mode = :edit
    when :edit
      key, = params['key']
      date, = params['date']
      subject, = params['subject']
      time_beg, = params['time_beg']
      time_end, = params['time_end']
      edit(key, date, subject, time_beg, time_end)
      @mode = :browse
    end
  end
  def do_remove(context, params)
    key, = params['key']
    remove(key)
  end
  def do_browse(context, params)
    @mode = :browse
  end
  def do_hide(context, params)
    @mode = :hide
  end
end

